    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2008, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * --------------
    028     * DialShape.java
    029     * --------------
    030     * (C) Copyright 2003-2008, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * Changes:
    036     * --------
    037     * 20-Aug-2003 : Version 1 (DG);
    038     * 12-Nov-2007 : Implemented hashCode() (DG);
    039     *
    040     */
    041
    042    package org.jfree.chart.plot;
    043
    044    import java.io.ObjectStreamException;
    045    import java.io.Serializable;
    046
    047    /**
    048     * Used to indicate the background shape for a
    049     * {@link org.jfree.chart.plot.MeterPlot}.
    050     */
    051    public final class DialShape implements Serializable {
    052
    053        /** For serialization. */
    054        private static final long serialVersionUID = -3471933055190251131L;
    055
    056        /** Circle. */
    057        public static final DialShape CIRCLE = new DialShape("DialShape.CIRCLE");
    058
    059        /** Chord. */
    060        public static final DialShape CHORD = new DialShape("DialShape.CHORD");
    061
    062        /** Pie. */
    063        public static final DialShape PIE = new DialShape("DialShape.PIE");
    064
    065        /** The name. */
    066        private String name;
    067
    068        /**
    069         * Private constructor.
    070         *
    071         * @param name  the name.
    072         */
    073        private DialShape(String name) {
    074            this.name = name;
    075        }
    076
    077        /**
    078         * Returns a string representing the object.
    079         *
    080         * @return The string.
    081         */
    082        public String toString() {
    083            return this.name;
    084        }
    085
    086        /**
    087         * Returns <code>true</code> if this object is equal to the specified
    088         * object, and <code>false</code> otherwise.
    089         *
    090         * @param obj  the other object.
    091         *
    092         * @return A boolean.
    093         */
    094        public boolean equals(Object obj) {
    095            if (this == obj) {
    096                return true;
    097            }
    098            if (!(obj instanceof DialShape)) {
    099                return false;
    100            }
    101            DialShape shape = (DialShape) obj;
    102            if (!this.name.equals(shape.toString())) {
    103                return false;
    104            }
    105            return true;
    106        }
    107
    108        /**
    109         * Returns a hash code for this instance.
    110         *
    111         * @return A hash code.
    112         */
    113        public int hashCode() {
    114            return this.name.hashCode();
    115        }
    116
    117        /**
    118         * Ensures that serialization returns the unique instances.
    119         *
    120         * @return The object.
    121         *
    122         * @throws ObjectStreamException if there is a problem.
    123         */
    124        private Object readResolve() throws ObjectStreamException {
    125            if (this.equals(DialShape.CIRCLE)) {
    126                return DialShape.CIRCLE;
    127            }
    128            else if (this.equals(DialShape.CHORD)) {
    129                return DialShape.CHORD;
    130            }
    131            else if (this.equals(DialShape.PIE)) {
    132                return DialShape.PIE;
    133            }
    134            return null;
    135        }
    136
    137    }